| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
FlatDataPack Class Reference
General

DataPack for flat data. More...

`#include <datapackbase.h>`

Inheritance diagram for FlatDataPack:
[legend]

## Public Member Functions
| FlatDataPack (const char *categry, Array2D< float > *)
| Array2D become mine (of course)
| FlatDataPack (const FlatDataPack &)
virtual Array2D< float > & | data ()
const Array2D< float > & | data () const
virtual uiString | dimName (bool dim0) const
virtual const UnitOfMeasure * | dimUnit (bool dim0, bool display) const
virtual uiString | dimUnitLbl (bool dim0, bool display, bool abbreviated=true, bool withparentheses=true) const
virtual bool | dimValuesInInt (const uiString &key, bool dim0) const
void | dumpInfo (StringPairSet &) const override
virtual void | getAltDimKeys (uiStringSet &, bool dim0) const
| First one is 'default'.
virtual void | getAltDimKeysUnitLbls (uiStringSet &, bool dim0, bool abbreviated=true, bool withparentheses=true) const
virtual double | getAltDimValue (int ikey, bool dim0, int idim0) const
virtual void | getAuxInfo (int idim0, int idim1, IOPar &) const
virtual Coord3 | getCoord (int, int) const
| int,int = Array2D position
virtual float | getPosDistance (bool dim0, float posfidx) const
virtual TrcKey | getTrcKey (int, int) const
virtual double | getZ (int, int) const
| overload to set Z also in getCoord
bool | isOK () const override
virtual bool | isVertical () const
float | nrKBytes () const override
virtual FlatPosData & | posData ()
const FlatPosData & | posData () const
virtual bool | posDataIsCoord () const
virtual int | size (bool dim0) const
Public Member Functions inherited from ZDataPack
ZDataPack & | setZDomain (const ZDataPack &)
virtual ZDataPack & | setZDomain (const ZDomain::Info &)
virtual const ZDomain::Info & | zDomain () const
bool | zInFeet () const
bool | zInMeter () const
bool | zIsTime () const
const UnitOfMeasure * | zUnit () const
Public Member Functions inherited from DataPack
virtual const char * | category () const
FullID | fullID (DataPackMgrID mgrid) const
DataPackID | id () const
DataPack * | obtain ()
void | release ()
Threads::Lock & | updateLock () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Protected Member Functions
| FlatDataPack (const char *category)
| ~FlatDataPack ()
Protected Member Functions inherited from ZDataPack
| ZDataPack (const char *categry)
| ZDataPack (const ZDataPack &)
| ~ZDataPack ()
const ZDomain::Info & | zDomain (bool display) const
const UnitOfMeasure * | zUnit (bool display) const
Protected Member Functions inherited from DataPack
| DataPack (const char *categry)
| DataPack (const DataPack &)
| ~DataPack ()
void | setCategory (const char *c)
void | setManager (const DataPackMgr *)
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Protected Attributes
Array2D< float > * | arr2d_ = nullptr
FlatPosData & | posdata_
Protected Attributes inherited from DataPack
const BufferString | category_
const DataPackID | id_
const DataPackMgr * | manager_ = nullptr
Threads::Lock | updatelock_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Private Member Functions
void | init ()

## Additional Inherited Members
Public Types inherited from DataPack
using | ID = DataPackID
using | MgrID = DataPackMgrID
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from DataPack
static DataPackID | cNoID ()
static DataPackID | cUdfID ()
static DataPackID | getID (const FullID &fid)
static const char * | sKeyCategory ()
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)
Static Protected Member Functions inherited from DataPack
static DataPackID | getNewID ()
| ensures a global data pack ID
static float | sKb2MbFac ()
| 1 / 1024

## Detailed Description

DataPack for flat data.

FlatPosData is initialized to ranges of 0 to sz-1 step 1.

<>

## Constructor & Destructor Documentation

## ◆ FlatDataPack() [1/3]

FlatDataPack::FlatDataPack | ( | const char * | categry,
|  | Array2D< float > * | )

Array2D become mine (of course)

## ◆ FlatDataPack() [2/3]

FlatDataPack::FlatDataPack | ( | const FlatDataPack & |  | ) |

## ◆ FlatDataPack() [3/3]

FlatDataPack::FlatDataPack | ( | const char * | category | ) |
| protected

For this you have to overload data() and the destructor

## ◆ ~FlatDataPack()

FlatDataPack::~FlatDataPack | ( |  | ) |
| protected

## Member Function Documentation

## ◆ data() [1/2]

virtual Array2D< float > & FlatDataPack::data | ( |  | ) |
| inline virtual

Reimplemented in MapDataPack.

## ◆ data() [2/2]

const Array2D< float > & FlatDataPack::data | ( |  | ) | const

## ◆ dimName()

virtual uiString FlatDataPack::dimName | ( | bool | dim0 | ) | const
| virtual

Reimplemented in MapDataPack, PreStack::Gather, RegularSeisFlatDataPack, RandomSeisFlatDataPack, and SeisTrcBufDataPack.

## ◆ dimUnit()

virtual const UnitOfMeasure * FlatDataPack::dimUnit | ( | bool | dim0,
|  | bool | display ) const
| inline virtual

Reimplemented in MapDataPack, PreStack::Gather, SeisTrcBufDataPack, RegularSeisFlatDataPack, and RandomSeisFlatDataPack.

## ◆ dimUnitLbl()

virtual uiString FlatDataPack::dimUnitLbl | ( | bool | dim0,
|  | bool | display,
|  | bool | abbreviated = true,
|  | bool | withparentheses = true ) const
| virtual

Reimplemented in MapDataPack, PreStack::Gather, SeisTrcBufDataPack, RegularSeisFlatDataPack, and RandomSeisFlatDataPack.

## ◆ dimValuesInInt()

virtual bool FlatDataPack::dimValuesInInt | ( | const uiString & | key,
|  | bool | dim0 ) const
| inline virtual

Reimplemented in MapDataPack, SeisTrcBufDataPack, and SeisFlatDataPack.

## ◆ dumpInfo()

void FlatDataPack::dumpInfo | ( | StringPairSet & |  | ) | const
| override virtual

Reimplemented from DataPack.

## ◆ getAltDimKeys()

virtual void FlatDataPack::getAltDimKeys | ( | uiStringSet & | ,
|  | bool | dim0 ) const
| inline virtual

First one is 'default'.

Reimplemented in SeisTrcBufDataPack, and SeisFlatDataPack.

## ◆ getAltDimKeysUnitLbls()

virtual void FlatDataPack::getAltDimKeysUnitLbls | ( | uiStringSet & | ,
|  | bool | dim0,
|  | bool | abbreviated = true,
|  | bool | withparentheses = true ) const
| inline virtual

Reimplemented in SeisTrcBufDataPack, and SeisFlatDataPack.

## ◆ getAltDimValue()

virtual double FlatDataPack::getAltDimValue | ( | int | ikey,
|  | bool | dim0,
|  | int | idim0 ) const
| virtual

Reimplemented in SeisFlatDataPack, and SeisTrcBufDataPack.

## ◆ getAuxInfo()

virtual void FlatDataPack::getAuxInfo | ( | int | idim0,
|  | int | idim1,
|  | IOPar & | ) const
| virtual

Reimplemented in PreStack::Gather, and SeisTrcBufDataPack.

## ◆ getCoord()

virtual Coord3 FlatDataPack::getCoord | ( | int | ,
|  | int | ) const
| virtual

int,int = Array2D position

Reimplemented in RegularSeisFlatDataPack, PreStack::Gather, SeisTrcBufDataPack, and RandomSeisFlatDataPack.

## ◆ getPosDistance()

virtual float FlatDataPack::getPosDistance | ( | bool | dim0,
|  | float | posfidx ) const
| inline virtual

Reimplemented in RegularSeisFlatDataPack, and RandomSeisFlatDataPack.

## ◆ getTrcKey()

virtual TrcKey FlatDataPack::getTrcKey | ( | int | ,
|  | int | ) const
| inline virtual

Reimplemented in RegularSeisFlatDataPack, RandomSeisFlatDataPack, SeisTrcBufDataPack, MapDataPack, and PreStack::Gather.

## ◆ getZ()

virtual double FlatDataPack::getZ | ( | int | ,
|  | int | ) const
| inline virtual

overload to set Z also in getCoord

Reimplemented in RegularSeisFlatDataPack, PreStack::Gather, SeisTrcBufDataPack, RandomSeisFlatDataPack, and MapDataPack.

## ◆ init()

void FlatDataPack::init | ( |  | ) |
| private

## ◆ isOK()

bool FlatDataPack::isOK | ( |  | ) | const
| override virtual

Reimplemented from DataPack.

## ◆ isVertical()

virtual bool FlatDataPack::isVertical | ( |  | ) | const
| inline virtual

Reimplemented in MapDataPack, RegularSeisFlatDataPack, RandomSeisFlatDataPack, and SeisFlatDataPack.

## ◆ nrKBytes()

float FlatDataPack::nrKBytes | ( |  | ) | const
| override virtual

Implements DataPack.

Reimplemented in SeisFlatDataPack.

## ◆ posData() [1/2]

virtual FlatPosData & FlatDataPack::posData | ( |  | ) |
| inline virtual

Reimplemented in MapDataPack.

## ◆ posData() [2/2]

const FlatPosData & FlatDataPack::posData | ( |  | ) | const

## ◆ posDataIsCoord()

virtual bool FlatDataPack::posDataIsCoord | ( |  | ) | const
| inline virtual

Reimplemented in MapDataPack, and SeisTrcBufDataPack.

## ◆ size()

virtual int FlatDataPack::size | ( | bool | dim0 | ) | const
| virtual

## Member Data Documentation

## ◆ arr2d_

Array2D<float>* FlatDataPack::arr2d_ = nullptr
| protected

## ◆ posdata_

FlatPosData& FlatDataPack::posdata_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025